<?php

Contao\System::loadLanguageFile('tl_tourism');

$GLOBALS['TL_DCA']['tl_offers_set'] = array
(

	// Config
	'config' => array
	(
		'dataContainer'               => 'Table',
		'ctable'                      => array('tl_offers'),
		'switchToEdit'                => true,
		'enableVersioning'            => true,
		'markAsCopy'                  => 'title',
		'onload_callback' => array
		(
			array('tl_offers_set', 'checkPermission'),
		),
		'oncreate_callback' => array
		(
			array('tl_offers_set', 'adjustPermissions')
		),
		'oncopy_callback' => array
		(
			array('tl_offers_set', 'adjustPermissions')
		),
		'onsubmit_callback' => array
		(

		),
		'sql' => array
		(
			'keys' => array
			(
				'id' => 'primary'
			)
		)
	),

	// List
	'list' => array
	(
		'sorting' => array
		(
			'mode'                    => 1,
			'fields'                  => array('title'),
			'flag'                    => 1,
			'panelLayout'             => 'filter;search,limit'
		),
		'label' => array
		(
			'fields'                  => array('title'),
			'format'                  => '%s'
		),
		'global_operations' => array
		(
			'all' => array
			(
				'label'               => &$GLOBALS['TL_LANG']['MSC']['all'],
				'href'                => 'act=select',
				'class'               => 'header_edit_all',
				'attributes'          => 'onclick="Backend.getScrollOffset()" accesskey="e"'
			)
		),
		'operations' => array
		(
			'edit' => array
			(
				'label'               => &$GLOBALS['TL_LANG']['tl_offers_set']['edit'],
				'href'                => 'table=tl_offers',
				'icon'                => 'edit.svg'
			),
			'editheader' => array
			(
				'label'               => &$GLOBALS['TL_LANG']['tl_offers_set']['editheader'],
				'href'                => 'act=edit',
				'icon'                => 'header.svg',
				'button_callback'     => array('tl_offers_set', 'editHeader')
			),
			'copy' => array
			(
				'label'               => &$GLOBALS['TL_LANG']['tl_offers_set']['copy'],
				'href'                => 'act=copy',
				'icon'                => 'copy.svg',
				'button_callback'     => array('tl_offers_set', 'copySet')
			),
			'delete' => array
			(
				'label'               => &$GLOBALS['TL_LANG']['tl_offers_set']['delete'],
				'href'                => 'act=delete',
				'icon'                => 'delete.svg',
				'attributes'          => 'onclick="if(!confirm(\'' . ($GLOBALS['TL_LANG']['MSC']['deleteConfirm'] ?? null) . '\'))return false;Backend.getScrollOffset()"',
				'button_callback'     => array('tl_offers_set', 'deleteSet')
			),
			'show' => array
			(
				'label'               => &$GLOBALS['TL_LANG']['tl_offers_set']['show'],
				'href'                => 'act=show',
				'icon'                => 'show.svg'
			)
		)
	),

	// Palettes
	'palettes' => array
	(
		'__selector__'                => array('protected'),
		'default'                     => '{title_legend},title,jumpTo,currency;{protected_legend:hide},protected'
	),

	// Subpalettes
	'subpalettes' => array
	(
		'protected'                   => 'groups'
	),

	// Fields
	'fields' => array
	(
		'id' => array
		(
			'sql'                     => "int(10) unsigned NOT NULL auto_increment"
		),
		'tstamp' => array
		(
			'sql'                     => "int(10) unsigned NOT NULL default 0"
		),
		'title' => array
		(
			'label'                   => &$GLOBALS['TL_LANG']['tl_offers_set']['title'],
			'exclude'                 => true,
			'search'                  => true,
			'inputType'               => 'text',
			'eval'                    => array('mandatory'=>true, 'maxlength'=>255, 'tl_class'=>'w50'),
			'sql'                     => "varchar(255) NOT NULL default ''"
		),
		'jumpTo' => array
		(
			'label'                   => &$GLOBALS['TL_LANG']['tl_offers_set']['jumpTo'],
			'exclude'                 => true,
			'inputType'               => 'pageTree',
			'foreignKey'              => 'tl_page.title',
			'eval'                    => array('mandatory'=>true, 'fieldType'=>'radio', 'tl_class'=>'clr'),
			'sql'                     => "int(10) unsigned NOT NULL default 0",
			'relation'                => array('type'=>'hasOne', 'load'=>'lazy')
		),
        'currency' => array
		(
            'label'                   => &$GLOBALS['TL_LANG']['tl_offers']['currency'],
            'default'                 => 'tl_offers_set.defaultCurrency',
            'exclude'                 => true,
            'inputType'               => 'select',
            //'options'                 => $GLOBALS['tl_hotel']['defaultCurrency']['options'],
            'options_callback'        => array('tl_offers_set', 'getCurrency'), 
            'eval'                    => array('tl_class' => 'w50'),
            'sql'                     => "varchar(255) NOT NULL default ''"
        ),
		'protected' => array
		(
			'label'                   => &$GLOBALS['TL_LANG']['tl_offers_set']['protected'],
			'exclude'                 => true,
			'filter'                  => true,
			'inputType'               => 'checkbox',
			'eval'                    => array('submitOnChange'=>true),
			'sql'                     => "char(1) NOT NULL default ''"
		),
		'groups' => array
		(
			'label'                   => &$GLOBALS['TL_LANG']['tl_offers_set']['groups'],
			'exclude'                 => true,
			'inputType'               => 'checkbox',
			'foreignKey'              => 'tl_member_group.name',
			'eval'                    => array('mandatory'=>true, 'multiple'=>true),
			'sql'                     => "blob NULL",
			'relation'                => array('type'=>'hasMany', 'load'=>'lazy')
		)
	)
);

/**
 * Provide miscellaneous methods that are used by the data configuration array.
 *
 * @property Contao\Offers $Offers
 */
class tl_offers_set extends Contao\Backend
{

	/**
	 * Import the back end user object
	 */
	public function __construct()
	{
		parent::__construct();
		$this->import('Contao\BackendUser', 'User');
	}

	/**
	 * Check permissions to edit table tl_offers_set
	 *
	 * @throws Contao\CoreBundle\Exception\AccessDeniedException
	 */
	public function checkPermission()
	{
		$bundles = Contao\System::getContainer()->getParameter('kernel.bundles');

		if ($this->User->isAdmin)
		{
			return;
		}

		// Set root IDs
		if (empty($this->User->offer) || !\is_array($this->User->offer))
		{
			$root = array(0);
		}
		else
		{
			$root = $this->User->offer;
		}

		$GLOBALS['TL_DCA']['tl_offers_set']['list']['sorting']['root'] = $root;

		// Check permissions to add sets
		if (!$this->User->hasAccess('create', 'offersp'))
		{
			$GLOBALS['TL_DCA']['tl_offers_set']['config']['closed'] = true;
			$GLOBALS['TL_DCA']['tl_offers_set']['config']['notCreatable'] = true;
			$GLOBALS['TL_DCA']['tl_offers_set']['config']['notCopyable'] = true;
		}

		// Check permissions to delete calendars
		if (!$this->User->hasAccess('delete', 'offersp'))
		{
			$GLOBALS['TL_DCA']['tl_offers_set']['config']['notDeletable'] = true;
		}

		/** @var Symfony\Component\HttpFoundation\Session\SessionInterface $objSession */
		$objSession = Contao\System::getContainer()->get('session');

		// Check current action
		switch (Contao\Input::get('act'))
		{
			case 'select':
				// Allow
				break;

			case 'create':
				if (!$this->User->hasAccess('create', 'offersp'))
				{
					throw new Contao\CoreBundle\Exception\AccessDeniedException('Not enough permissions to create offer sets.');
				}
				break;

			case 'edit':
			case 'copy':
			case 'delete':
			case 'show':
				if (!\in_array(Contao\Input::get('id'), $root) || (Contao\Input::get('act') == 'delete' && !$this->User->hasAccess('delete', 'offersp')))
				{
					throw new Contao\CoreBundle\Exception\AccessDeniedException('Not enough permissions to ' . Contao\Input::get('act') . ' offer set ID ' . Contao\Input::get('id') . '.');
				}
				break;

			case 'editAll':
			case 'deleteAll':
			case 'overrideAll':
			case 'copyAll':
				$session = $objSession->all();
				if (Contao\Input::get('act') == 'deleteAll' && !$this->User->hasAccess('delete', 'offersp'))
				{
					$session['CURRENT']['IDS'] = array();
				}
				else
				{
					$session['CURRENT']['IDS'] = array_intersect((array) $session['CURRENT']['IDS'], $root);
				}
				$objSession->replace($session);
				break;

			default:
				if (\strlen(Contao\Input::get('act')))
				{
					throw new Contao\CoreBundle\Exception\AccessDeniedException('Not enough permissions to ' . Contao\Input::get('act') . ' offer sets.');
				}
				break;
		}
	}

	/**
	 * Add the new set to the permissions
	 *
	 * @param $insertId
	 */
	public function adjustPermissions($insertId)
	{
		// The oncreate_callback passes $insertId as second argument
		if (\func_num_args() == 4)
		{
			$insertId = func_get_arg(1);
		}

		if ($this->User->isAdmin)
		{
			return;
		}

		// Set root IDs
		if (empty($this->User->offer) || !\is_array($this->User->offer))
		{
			$root = array(0);
		}
		else
		{
			$root = $this->User->offer;
		}

		// The set is enabled already
		if (\in_array($insertId, $root))
		{
			return;
		}

		/** @var Symfony\Component\HttpFoundation\Session\Attribute\AttributeBagInterface $objSessionBag */
		$objSessionBag = Contao\System::getContainer()->get('session')->getBag('contao_backend');

		$arrNew = $objSessionBag->get('new_records');

		if (\is_array($arrNew['tl_offers_set']) && \in_array($insertId, $arrNew['tl_offers_set']))
		{
			// Add the permissions on group level
			if ($this->User->inherit != 'custom')
			{
				$objGroup = $this->Database->execute("SELECT id, offer, offersp FROM tl_user_group WHERE id IN(" . implode(',', array_map('\intval', $this->User->groups)) . ")");

				while ($objGroup->next())
				{
					$arrNewp = Contao\StringUtil::deserialize($objGroup->offersp);

					if (\is_array($arrNewp) && \in_array('create', $arrNewp))
					{
						$arrOffers = Contao\StringUtil::deserialize($objGroup->offer, true);
						$arrOffers[] = $insertId;

						$this->Database->prepare("UPDATE tl_user_group SET offer=? WHERE id=?")
									   ->execute(serialize($arrOffers), $objGroup->id);
					}
				}
			}

			// Add the permissions on user level
			if ($this->User->inherit != 'group')
			{
				$objUser = $this->Database->prepare("SELECT offer, offersp FROM tl_user WHERE id=?")
										   ->limit(1)
										   ->execute($this->User->id);

				$arrNewp = Contao\StringUtil::deserialize($objUser->offersp);

				if (\is_array($arrNewp) && \in_array('create', $arrNewp))
				{
					$arrOffers = Contao\StringUtil::deserialize($objUser->offer, true);
					$arrOffers[] = $insertId;

					$this->Database->prepare("UPDATE tl_user SET offer=? WHERE id=?")
								   ->execute(serialize($arrOffers), $this->User->id);
				}
			}

			// Add the new element to the user object
			$root[] = $insertId;
			$this->User->offer = $root;
		}
	}


	/**
	 * Return the edit header button
	 *
	 * @param array  $row
	 * @param string $href
	 * @param string $label
	 * @param string $title
	 * @param string $icon
	 * @param string $attributes
	 *
	 * @return string
	 */
	public function editHeader($row, $href, $label, $title, $icon, $attributes)
	{
		return $this->User->canEditFieldsOf('tl_offers_set') ? '<a href="'.$this->addToUrl($href.'&amp;id='.$row['id']).'" title="'.Contao\StringUtil::specialchars($title).'"'.$attributes.'>'.Contao\Image::getHtml($icon, $label).'</a> ' : Contao\Image::getHtml(preg_replace('/\.svg$/i', '_.svg', $icon)).' ';
	}

	/**
	 * Return the copy set button
	 *
	 * @param array  $row
	 * @param string $href
	 * @param string $label
	 * @param string $title
	 * @param string $icon
	 * @param string $attributes
	 *
	 * @return string
	 */
	public function copySet($row, $href, $label, $title, $icon, $attributes)
	{
		return $this->User->hasAccess('create', 'offersp') ? '<a href="'.$this->addToUrl($href.'&amp;id='.$row['id']).'" title="'.Contao\StringUtil::specialchars($title).'"'.$attributes.'>'.Contao\Image::getHtml($icon, $label).'</a> ' : Contao\Image::getHtml(preg_replace('/\.svg$/i', '_.svg', $icon)).' ';
	}

	/**
	 * Return the delete set button
	 *
	 * @param array  $row
	 * @param string $href
	 * @param string $label
	 * @param string $title
	 * @param string $icon
	 * @param string $attributes
	 *
	 * @return string
	 */
	public function deleteSet($row, $href, $label, $title, $icon, $attributes)
	{
		return $this->User->hasAccess('delete', 'offersp') ? '<a href="'.$this->addToUrl($href.'&amp;id='.$row['id']).'" title="'.Contao\StringUtil::specialchars($title).'"'.$attributes.'>'.Contao\Image::getHtml($icon, $label).'</a> ' : Contao\Image::getHtml(preg_replace('/\.svg$/i', '_.svg', $icon)).' ';
	}

	/**
	 * Get currency
	 */
	public function getCurrency()
	{
		$weekDays = array(
			'USD' => $GLOBALS['TL_LANG']['tl_tourism']['USD'], 
			'EUR' => $GLOBALS['TL_LANG']['tl_tourism']['EUR'], 
			'JPY' => $GLOBALS['TL_LANG']['tl_tourism']['JPY'], 
			'GBP' => $GLOBALS['TL_LANG']['tl_tourism']['GBP'], 
			'AUD' => $GLOBALS['TL_LANG']['tl_tourism']['AUD'], 
			'CAD' => $GLOBALS['TL_LANG']['tl_tourism']['CAD'], 
			'CHF' => $GLOBALS['TL_LANG']['tl_tourism']['CHF']
		);
		return $weekDays;
	}
}
